/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO_TRACK)

#include "JSDataCue.h"

#include "DataCue.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "ScriptExecutionContext.h"
#include "URL.h"
#include <runtime/Error.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for constructor */

static const HashTableValue JSDataCueConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSDataCueConstructorTable = { 1, 0, false, JSDataCueConstructorTableValues, 0 };
EncodedJSValue JSC_HOST_CALL JSDataCueConstructor::constructJSDataCue(ExecState* exec)
{
    JSDataCueConstructor* castedThis = jsCast<JSDataCueConstructor*>(exec->callee());
    if (exec->argumentCount() < 3)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    double startTime(exec->argument(0).toNumber(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());
    double endTime(exec->argument(1).toNumber(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());
    ArrayBuffer* data(toArrayBuffer(exec->argument(2)));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());
    ScriptExecutionContext* context = castedThis->scriptExecutionContext();
    if (!context)
        return throwVMError(exec, createReferenceError(exec, "DataCue constructor associated document is unavailable"));
    RefPtr<DataCue> object = DataCue::create(*context, startTime, endTime, data);
    return JSValue::encode(asObject(toJS(exec, castedThis->globalObject(), object.get())));
}

const ClassInfo JSDataCueConstructor::s_info = { "DataCueConstructor", &Base::s_info, &JSDataCueConstructorTable, 0, CREATE_METHOD_TABLE(JSDataCueConstructor) };

JSDataCueConstructor::JSDataCueConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSDataCueConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSDataCuePrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(3), ReadOnly | DontDelete | DontEnum);
}

bool JSDataCueConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSDataCueConstructor, JSDOMWrapper>(exec, JSDataCueConstructorTable, jsCast<JSDataCueConstructor*>(object), propertyName, slot);
}

ConstructType JSDataCueConstructor::getConstructData(JSCell*, ConstructData& constructData)
{
    constructData.native.function = constructJSDataCue;
    return ConstructTypeHost;
}

/* Hash table for prototype */

static const HashTableValue JSDataCuePrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDataCueConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "data", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDataCueData), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSDataCueData) },
    { "text", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDataCueText), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSDataCuePrototypeTable = { 8, 7, true, JSDataCuePrototypeTableValues, 0 };
const ClassInfo JSDataCuePrototype::s_info = { "DataCuePrototype", &Base::s_info, &JSDataCuePrototypeTable, 0, CREATE_METHOD_TABLE(JSDataCuePrototype) };

JSObject* JSDataCuePrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSDataCue>(vm, globalObject);
}

bool JSDataCuePrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSDataCuePrototype* thisObject = jsCast<JSDataCuePrototype*>(object);
    return getStaticPropertySlot<JSDataCuePrototype, JSObject>(exec, JSDataCuePrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSDataCue::s_info = { "DataCue", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSDataCue) };

JSDataCue::JSDataCue(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<DataCue> impl)
    : JSTextTrackCue(structure, globalObject, impl)
{
}

void JSDataCue::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSDataCue::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSDataCuePrototype::create(vm, globalObject, JSDataCuePrototype::createStructure(vm, globalObject, JSTextTrackCuePrototype::self(vm, globalObject)));
}

bool JSDataCue::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSDataCue* thisObject = jsCast<JSDataCue*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return Base::getOwnPropertySlot(thisObject, exec, propertyName, slot);
}

EncodedJSValue jsDataCueData(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDataCue* castedThis = jsDynamicCast<JSDataCue*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis) {
        if (jsDynamicCast<JSDataCuePrototype*>(slotBase)) {
            ScriptExecutionContext* scriptExecutionContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
            scriptExecutionContext->addConsoleMessage(MessageSource::JS, MessageLevel::Error, String("Deprecated attempt to access property 'data' on a non-DataCue object."));
            return JSValue::encode(jsUndefined());
        }
        return throwVMTypeError(exec);
    }
    UNUSED_PARAM(exec);
    DataCue& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.data()));
    return JSValue::encode(result);
}


EncodedJSValue jsDataCueText(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDataCue* castedThis = jsDynamicCast<JSDataCue*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis) {
        if (jsDynamicCast<JSDataCuePrototype*>(slotBase)) {
            ScriptExecutionContext* scriptExecutionContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
            scriptExecutionContext->addConsoleMessage(MessageSource::JS, MessageLevel::Error, String("Deprecated attempt to access property 'text' on a non-DataCue object."));
            return JSValue::encode(jsUndefined());
        }
        return throwVMTypeError(exec);
    }
    UNUSED_PARAM(exec);
    bool isNull = false;
    DataCue& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.text(isNull));
    if (isNull)
        return JSValue::encode(jsNull());
    return JSValue::encode(result);
}


EncodedJSValue jsDataCueConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(baseValue);
    UNUSED_PARAM(thisValue);
    JSDataCuePrototype* domObject = jsDynamicCast<JSDataCuePrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSDataCue::getConstructor(exec->vm(), domObject->globalObject()));
}

void setJSDataCueData(ExecState* exec, JSObject* /* baseObject */, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(exec);
    JSDataCue* castedThis = jsDynamicCast<JSDataCue*>(JSValue::decode(thisValue));
    if (!castedThis) {
        throwVMTypeError(exec);
        return;
    }
    DataCue& impl = castedThis->impl();
    ArrayBuffer* nativeValue(toArrayBuffer(value));
    if (exec->hadException())
        return;
    impl.setData(nativeValue);
}


JSValue JSDataCue::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSDataCueConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}

#endif // ENABLE(VIDEO_TRACK)
