/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(NETWORK_INFO)

#include "JSNetworkInfoConnection.h"

#include "Event.h"
#include "EventListener.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSEvent.h"
#include "JSEventListener.h"
#include "NetworkInfoConnection.h"
#include "ScriptExecutionContext.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSNetworkInfoConnectionPrototypeTableValues[] =
{
    { "bandwidth", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNetworkInfoConnectionBandwidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "metered", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNetworkInfoConnectionMetered), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "onwebkitnetworkinfochange", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNetworkInfoConnectionOnwebkitnetworkinfochange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSNetworkInfoConnectionOnwebkitnetworkinfochange) },
    { "addEventListener", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsNetworkInfoConnectionPrototypeFunctionAddEventListener), (intptr_t) (2) },
    { "removeEventListener", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsNetworkInfoConnectionPrototypeFunctionRemoveEventListener), (intptr_t) (2) },
    { "dispatchEvent", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsNetworkInfoConnectionPrototypeFunctionDispatchEvent), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSNetworkInfoConnectionPrototypeTable = { 17, 15, true, JSNetworkInfoConnectionPrototypeTableValues, 0 };
const ClassInfo JSNetworkInfoConnectionPrototype::s_info = { "NetworkInfoConnectionPrototype", &Base::s_info, &JSNetworkInfoConnectionPrototypeTable, 0, CREATE_METHOD_TABLE(JSNetworkInfoConnectionPrototype) };

JSObject* JSNetworkInfoConnectionPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSNetworkInfoConnection>(vm, globalObject);
}

bool JSNetworkInfoConnectionPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSNetworkInfoConnectionPrototype* thisObject = jsCast<JSNetworkInfoConnectionPrototype*>(object);
    return getStaticPropertySlot<JSNetworkInfoConnectionPrototype, JSObject>(exec, JSNetworkInfoConnectionPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSNetworkInfoConnection::s_info = { "NetworkInfoConnection", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSNetworkInfoConnection) };

JSNetworkInfoConnection::JSNetworkInfoConnection(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<NetworkInfoConnection> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSNetworkInfoConnection::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSNetworkInfoConnection::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSNetworkInfoConnectionPrototype::create(vm, globalObject, JSNetworkInfoConnectionPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSNetworkInfoConnection::destroy(JSC::JSCell* cell)
{
    JSNetworkInfoConnection* thisObject = static_cast<JSNetworkInfoConnection*>(cell);
    thisObject->JSNetworkInfoConnection::~JSNetworkInfoConnection();
}

JSNetworkInfoConnection::~JSNetworkInfoConnection()
{
    releaseImplIfNotNull();
}

EncodedJSValue jsNetworkInfoConnectionBandwidth(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis) {
        if (jsDynamicCast<JSNetworkInfoConnectionPrototype*>(slotBase)) {
            ScriptExecutionContext* scriptExecutionContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
            scriptExecutionContext->addConsoleMessage(MessageSource::JS, MessageLevel::Error, String("Deprecated attempt to access property 'bandwidth' on a non-NetworkInfoConnection object."));
            return JSValue::encode(jsUndefined());
        }
        return throwVMTypeError(exec);
    }
    UNUSED_PARAM(exec);
    NetworkInfoConnection& impl = castedThis->impl();
    JSValue result = jsNumber(impl.bandwidth());
    return JSValue::encode(result);
}


EncodedJSValue jsNetworkInfoConnectionMetered(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis) {
        if (jsDynamicCast<JSNetworkInfoConnectionPrototype*>(slotBase)) {
            ScriptExecutionContext* scriptExecutionContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
            scriptExecutionContext->addConsoleMessage(MessageSource::JS, MessageLevel::Error, String("Deprecated attempt to access property 'metered' on a non-NetworkInfoConnection object."));
            return JSValue::encode(jsUndefined());
        }
        return throwVMTypeError(exec);
    }
    UNUSED_PARAM(exec);
    NetworkInfoConnection& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.metered());
    return JSValue::encode(result);
}


EncodedJSValue jsNetworkInfoConnectionOnwebkitnetworkinfochange(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis) {
        if (jsDynamicCast<JSNetworkInfoConnectionPrototype*>(slotBase)) {
            ScriptExecutionContext* scriptExecutionContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
            scriptExecutionContext->addConsoleMessage(MessageSource::JS, MessageLevel::Error, String("Deprecated attempt to access property 'onwebkitnetworkinfochange' on a non-NetworkInfoConnection object."));
            return JSValue::encode(jsUndefined());
        }
        return throwVMTypeError(exec);
    }
    UNUSED_PARAM(exec);
    NetworkInfoConnection& impl = castedThis->impl();
    if (EventListener* listener = impl.onwebkitnetworkinfochange()) {
        if (const JSEventListener* jsListener = JSEventListener::cast(listener)) {
            if (JSObject* jsFunction = jsListener->jsFunction(impl.scriptExecutionContext()))
                return JSValue::encode(jsFunction);
        }
    }
    return JSValue::encode(jsNull());
}


void setJSNetworkInfoConnectionOnwebkitnetworkinfochange(ExecState* exec, JSObject* /* baseObject */, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(exec);
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(JSValue::decode(thisValue));
    if (!castedThis) {
        throwVMTypeError(exec);
        return;
    }
    UNUSED_PARAM(exec);
    NetworkInfoConnection& impl = castedThis->impl();
    impl.setOnwebkitnetworkinfochange(createJSAttributeEventListener(exec, value, castedThis));
}


EncodedJSValue JSC_HOST_CALL jsNetworkInfoConnectionPrototypeFunctionAddEventListener(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSNetworkInfoConnection::info());
    NetworkInfoConnection& impl = castedThis->impl();
    JSValue listener = exec->argument(1);
    if (!listener.isObject())
        return JSValue::encode(jsUndefined());
    impl.addEventListener(exec->argument(0).toString(exec)->value(exec), JSEventListener::create(asObject(listener), castedThis, false, currentWorld(exec)), exec->argument(2).toBoolean(exec));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsNetworkInfoConnectionPrototypeFunctionRemoveEventListener(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSNetworkInfoConnection::info());
    NetworkInfoConnection& impl = castedThis->impl();
    JSValue listener = exec->argument(1);
    if (!listener.isObject())
        return JSValue::encode(jsUndefined());
    impl.removeEventListener(exec->argument(0).toString(exec)->value(exec), JSEventListener::create(asObject(listener), castedThis, false, currentWorld(exec)).get(), exec->argument(2).toBoolean(exec));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsNetworkInfoConnectionPrototypeFunctionDispatchEvent(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSNetworkInfoConnection* castedThis = jsDynamicCast<JSNetworkInfoConnection*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSNetworkInfoConnection::info());
    NetworkInfoConnection& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Event* evt(toEvent(exec->argument(0)));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.dispatchEvent(evt, ec));
    setDOMException(exec, ec);
    return JSValue::encode(result);
}

void JSNetworkInfoConnection::visitChildren(JSCell* cell, SlotVisitor& visitor)
{
    JSNetworkInfoConnection* thisObject = jsCast<JSNetworkInfoConnection*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    COMPILE_ASSERT(StructureFlags & OverridesVisitChildren, OverridesVisitChildrenWithoutSettingFlag);
    ASSERT(thisObject->structure()->typeInfo().overridesVisitChildren());
    Base::visitChildren(thisObject, visitor);
    thisObject->impl().visitJSEventListeners(visitor);
}

bool JSNetworkInfoConnectionOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSNetworkInfoConnection* jsNetworkInfoConnection = jsCast<JSNetworkInfoConnection*>(handle.get().asCell());
    if (jsNetworkInfoConnection->impl().hasPendingActivity())
        return true;
    if (jsNetworkInfoConnection->impl().isFiringEventListeners())
        return true;
    UNUSED_PARAM(visitor);
    return false;
}

void JSNetworkInfoConnectionOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSNetworkInfoConnection* jsNetworkInfoConnection = jsCast<JSNetworkInfoConnection*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsNetworkInfoConnection->impl(), jsNetworkInfoConnection);
    jsNetworkInfoConnection->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7NetworkInfoConnection@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21NetworkInfoConnectionE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, NetworkInfoConnection* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSNetworkInfoConnection>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7NetworkInfoConnection@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore21NetworkInfoConnectionE[2];
#if COMPILER(CLANG)
    // If this fails NetworkInfoConnection does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(NetworkInfoConnection), NetworkInfoConnection_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // NetworkInfoConnection has subclasses. If NetworkInfoConnection has subclasses that get passed
    // to toJS() we currently require NetworkInfoConnection you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<NetworkInfoConnection>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSNetworkInfoConnection>(exec, globalObject, impl);
}

NetworkInfoConnection* toNetworkInfoConnection(JSC::JSValue value)
{
    return value.inherits(JSNetworkInfoConnection::info()) ? &jsCast<JSNetworkInfoConnection*>(value)->impl() : 0;
}

}

#endif // ENABLE(NETWORK_INFO)
